%define rhugversion 20040123
%define fullname jakarta-%{name}
%define rhugsource1 %{fullname}-%{version}-src upstream/tomcat
%define rhugsource2 %{fullname}-connectors-%{version}-src upstream/connectors
%define rhugpatches 4 5 6 7 15 16 20 21 23 24 25

Summary: Java Servlet container
Name: tomcat
Version: 4.1.27
Release: 13
URL: http://jakarta.apache.org/tomcat/
Source: rhug-%{fullname}-%{rhugversion}.tar.bz2
Source1: %{fullname}-%{version}-src.tar.gz
Source2: %{fullname}-connectors-%{version}-src.tar.gz
Source3: tomcat.init
Source4: tomcat.logrotate
Source5: tomcat.sysconfig
Source7: build.properties.webapps
Source8: admin.xml
Source9: manager.xml
Source10: README.multiple
Source11: catalina.libs
Source12: catalina.preloads
Source13: realms.sql
Source14: tomcat-tests-%{version}-%{release}.tar.bz2
Source60: jk2.conf
Source61: workers2.properties
Source62: jk2.properties
Patch1: %{name}-rhjpp.patch
Patch3: %{name}-install.patch
Patch4: %{name}-nag15572.patch
Patch5: %{name}-pr9547.patch
Patch6: %{name}-pr8899.patch
Patch7: %{name}-pr8823.patch
Patch10: %{name}-nag19469.patch
Patch12: %{name}-bz91007.patch
Patch14: %{name}-manager.patch
Patch15: %{name}-pr11330.patch
Patch16: %{name}-pr11349.patch
Patch18: %{name}-bz98528.patch
Patch19: %{name}-admin.patch
Patch20: %{name}-jsse.patch
Patch21: %{name}-solib.patch
Patch22: %{name}-jvmversion.patch
Patch23: %{name}-nag22096.patch
Patch24: %{name}-daemon.patch
Patch25: %{name}-nag23853.patch
Patch26: %{name}-nodaemon.patch
Patch60: mod_jk2-nojdk.patch
License: Apache Software License
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: gcc34-c++
BuildPrereq: gcc34-java >= 3.4.0-1
BuildPrereq: commons-logging >= 1.0.2-15
BuildPrereq: servletapi >= 2.3-4
BuildPrereq: xerces-j >= 2.2.1-16
BuildPrereq: ant >= 1.5.2-26
BuildPrereq: commons-collections >= 2.1-12
BuildPrereq: commons-beanutils >= 1.6.1-13
BuildPrereq: commons-digester >= 1.4.1-13
BuildPrereq: jakarta-regexp >= 1.2-15
BuildPrereq: commons-fileupload >= 1.0-8
BuildPrereq: mx4j >= 1.1.1-9
BuildPrereq: commons-modeler >= 1.0-8
BuildPrereq: javamail >= 20031006-4
BuildPrereq: struts >= 1.0.2-4
BuildPrereq: autoconf >= 2.52, automake, libtool
BuildPrereq: httpd-devel >= 2.0.46-5
BuildPrereq: python >= 2.2
Requires: libstdc++34
Requires: gcc34-java >= 3.4.0-1
Requires: commons-logging >= 1.0.2-15
Requires: servletapi >= 2.3-4
Requires: xerces-j >= 2.2.1-16
Requires: ant-core >= 1.5.2-23
Requires: commons-collections >= 2.1-12
Requires: commons-beanutils >= 1.6.1-13
Requires: commons-digester >= 1.4.1-13
Requires: jakarta-regexp >= 1.2-15
Requires: commons-fileupload >= 1.0-8
Requires: mx4j >= 1.1.1-9
Requires: commons-modeler >= 1.0-8
Requires: jaf >= 20030319-4
Requires: javamail >= 20031006-4
Requires: tomcat-libs = %{version}-%{release}
Provides: tomcat4 = %{version}-%{release}
Conflicts: struts < 1.0.2-2
Prereq: /sbin/chkconfig, /sbin/service
Prereq: /usr/sbin/useradd, /usr/sbin/groupadd
Prereq: /usr/bin/chsh

%description 
Tomcat is the official Reference Implementation for the Java Servlet
and JavaServer Pages technologies.  The Java Servlet and JavaServer
Pages specifications are developed by Sun under the Java Community
Process.

%package libs
Summary: The shared libraries used by Tomcat.
Group: System Environment/Libraries
Prereq: redhat-java-rpm-scripts >= 1.0.2-2
Requires: libgcj34 >= 3.4.0-1
Requires: commons-logging >= 1.0.2-15
Requires: servletapi >= 2.3-4
Requires: xerces-j >= 2.2.1-16
Requires: ant-core >= 1.5.2-23
Requires: commons-collections >= 2.1-12
Requires: commons-beanutils >= 1.6.1-13
Requires: commons-digester >= 1.4.1-13
Requires: jakarta-regexp >= 1.2-15
Requires: commons-fileupload >= 1.0-8
Requires: mx4j >= 1.1.1-9
Requires: commons-modeler >= 1.0-8
Requires: javamail >= 20031006-4
Requires: commons-pool >= 1.1-3
Requires: commons-dbcp >= 1.1-3

%description libs
The tomcat-libs package contains the libraries required by Tomcat.

%package devel
Summary: CNI headers for developing Tomcat applications
Group: Development/Libraries
Requires: tomcat-libs = %{version}-%{release}

%description devel 
The tomcat-devel package contains the headers required to develop
Cygnus Native Interface (CNI) extensions that use Tomcat.

%package -n mod_jk2
Summary: AJP connector module for the Apache HTTP server.
Group: System Environment/Daemons
Requires: httpd
Requires: httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing)

%description -n mod_jk2
Mod_jk2 allows the Apache Web server to connect to application servers
using the AJP protocol.  This allows web applications to be integrated
seamlessly into your Apache server's URI space and utilize Apache
features such as SSL processing.

%package test
Summary: Testsuite for Tomcat
Group: Development/Quality Assurance
Requires: tomcat = %{version}-%{release}
BuildPrereq: python >= 2.2
Requires: python >= 2.2
%if 0
Requires: mysql-jdbc-tomcat, MySQL-python
Requires: postgresql-jdbc-tomcat, postgresql-python
%endif

%description test
The tomcat-test package contains a testsuite for Tomcat.

%prep
%setup -q -a 1 -a 2 -a 14
mv %{rhugsource1}
mv %{rhugsource2}
%patch1 -p0 -b .rhjpp
%patch3 -p0 -b .install
%patch4 -p0 -b .nag15572
%patch5 -p1 -b .pr9547
%patch6 -p1 -b .pr8899
%patch7 -p0 -b .pr8823
%patch10 -p0 -b .nag19469
%patch12 -p0 -b .bz91007
%patch14 -p0 -b .manager
%patch15 -p0 -b .pr11330
%patch16 -p0 -b .pr11349
%patch18 -p0 -b .bz98528
%patch19 -p0
%patch20 -p0 -b .jsse
%patch21 -p0 -b .solib
%patch22 -p0 -b .jvmversion
%patch23 -p0 -b .nag22096
%patch24 -p0 -b .daemon
%patch25 -p0 -b .nag23853
%ifarch ppc64
%patch26 -p0 -b .nodaemon
%endif
mv ChangeLog ChangeLog.rhug
mv TODO TODO.rhug
for f in ServerInfo.properties; do
    f=upstream/tomcat/catalina/src/share/org/apache/catalina/util/$f
    sed -e "s:@VERSION@:%{version}-%{release}:g" \
        < $f > $f.tmp && mv -f $f.tmp $f
done
sed -e "s:@BASEDIR@:`pwd`:g" < %{SOURCE7} > upstream/tomcat/build.properties
cp -a %{SOURCE10} .
sed -e "/^@PGSQL@/d" -e "s/^@MYSQL@ //" \
    -e "s:@DOCDIR@:%{_docdir}/%{name}-%{version}:g" \
    < %{SOURCE13} > MySQL-REALM.sql
sed -e "/^@MYSQL@/d" -e "s/^@PGSQL@ //" \
    -e "s:@DOCDIR@:%{_docdir}/%{name}-%{version}:g" \
    < %{SOURCE13} > PostgreSQL-REALM.sql
python test/harness/config.py --connector=jk2 --realm=file --examples=true | \
    sed -e "s:@DOCDIR@:%{_docdir}/%{name}-%{version}:g" \
    > upstream/tomcat/catalina/src/conf/server.xml
python test/harness/config.py --connector=jk2 --realm=file | \
    sed -e "s:@DOCDIR@:%{_docdir}/%{name}-%{version}:g" \
    > upstream/tomcat/catalina/src/conf/server-noexamples.xml.config

# Prepare mod_jk2
cd upstream/connectors/jk/native2
%patch60 -p1 -b .nojdk
sh buildconf.sh

%build
CC=gcc34 CXX=g++34 GCJ=gcj34 GCJH=gcjh34 \
./configure --disable-static --prefix=%{_prefix} --libdir=%{_libdir} \
    --sysconfdir=%{_sysconfdir}
make

# Build the webapps
(cd upstream/tomcat/webapps && ant)

# Build mod_jk2
cd upstream/connectors/jk/native2
./configure --with-apxs2=%{_sbindir}/apxs
make jk2-build-apxs

# Build the testsuite
cd ../../../../test
LOGLEVEL=debug INSTDIR=%{_datadir}/tomcat/test/tests \
    python -c "from harness import util; util.makeAll('tests')" | \
    sed -e "s:^.* \[DEBUG\] ::"

%install
rm -rf ${RPM_BUILD_ROOT}
%makeinstall
rm -f ${RPM_BUILD_ROOT}%{_libdir}/*.la
find ${RPM_BUILD_ROOT}%{_libdir} -type l | xargs rm -f
rm -f ${RPM_BUILD_ROOT}%{_sysconfdir}/tomcat/catalina.conf.xml
rm -f ${RPM_BUILD_ROOT}%{_sysconfdir}/tomcat/catalina.policy
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/tomcat
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/cache/tomcat
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/run/tomcat

# Build $CATALINA_HOME
%define tcdir ${RPM_BUILD_ROOT}%{_datadir}/tomcat
mkdir -p %{tcdir}/{common,server,shared}/{classes,lib}
ln -s ../../../%{_sysconfdir}/tomcat %{tcdir}/conf
ln -s ../../../%{_localstatedir}/log/tomcat %{tcdir}/logs
ln -s ../../../%{_localstatedir}/lib/tomcat %{tcdir}/webapps
ln -s ../../../%{_localstatedir}/cache/tomcat %{tcdir}/work
for dir in common server shared; do
    for file in `grep "^$dir " %{SOURCE11} | sed "s:^$dir \(ANYVER \)\?::"`; do
	# locate the file we wish to link to
	ext=`echo $file | sed 's:^.*\.:.:'`
	case "$ext" in
	.jar) targetdir=%{_datadir}/java ;;
	.so)  targetdir=%{_libdir} ;;
	*) echo 1>&2 "unhandled extension $ext" ; exit 1
	esac
	base=`basename $file $ext`
	if grep -q "^$dir ANYVER $file" %{SOURCE11}; then
	    target=$targetdir/$base$ext
	elif [ -f $RPM_BUILD_ROOT$targetdir/$base-%{version}$ext ]; then
	    target=$targetdir/$base-%{version}$ext
	elif [ -L $targetdir/xerces-j/$base$ext ]; then
	    target=`ls -l $targetdir/xerces-j/$base$ext | \
	        sed "s:.* -> \.\./:$targetdir/:"`
	    if [ ! -f $target ]; then
		echo 1>&2 "$targetdir/xerces-j/$base$ext is a broken link"
		exit 1
	    fi
	elif [ -L $targetdir/$base$ext ]; then
	    target=`ls -l $targetdir/$base$ext | sed "s:.* -> :$targetdir/:"`
	    if [ ! -f $target ]; then
		echo 1>&2 "$targetdir/$base$ext is a broken link" ; exit 1
	    fi
	else
	    echo 1>&2 "can't locate $file" ; exit 1
	fi
	# translate the target into a relative path
	link=%{_datadir}/tomcat/$dir/lib/$file
	common=
	for element in `dirname $target | sed 's:$:/:; s:/:/ :g'`; do
	    if echo $link | grep -q "^$common$element"; then
		common=$common$element
	    else
		break
	    fi
	done
	targetdir=`dirname $link | sed "s:^$common::; s:[^/]*:..:g"`
	target=$targetdir/`echo $target | sed "s:^$common::"`
	ln -s $target $RPM_BUILD_ROOT$link
    done
done
install -m644 $RPM_SOURCE_DIR/catalina.preloads %{tcdir}/common/preloads

# Install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
sed -e 's:@DOCDIR@:%{_docdir}/%{name}-%{version}:g' \
    < $RPM_SOURCE_DIR/tomcat.init \
    > $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/tomcat
chmod 755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/tomcat
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m644 $RPM_SOURCE_DIR/tomcat.sysconfig \
    $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/tomcat

# Install log rotation stuff
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m644 $RPM_SOURCE_DIR/tomcat.logrotate \
    $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/tomcat

# Install the webapps
(cd upstream/tomcat/webapps && ant deploy)
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib
cp -a upstream/tomcat/build/webapps \
    ${RPM_BUILD_ROOT}%{_localstatedir}/lib/tomcat
cp -a upstream/tomcat/build/server/webapps %{tcdir}/server
install -m644 $RPM_SOURCE_DIR/admin.xml $RPM_SOURCE_DIR/manager.xml \
    $RPM_BUILD_ROOT%{_localstatedir}/lib/tomcat

# Install mod_jk2
mkdir -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules
libtool --mode=install install -m 755 \
    upstream/connectors/jk/native2/server/apache2/mod_jk2.la \
    $RPM_BUILD_ROOT%{_libdir}/httpd/modules
rm -f $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_jk2.*a
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/jk2.conf \
   $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf
install -m 644 $RPM_SOURCE_DIR/workers2.properties \
   $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf/
install -m 644 $RPM_SOURCE_DIR/jk2.properties \
   $RPM_BUILD_ROOT%{_sysconfdir}/tomcat/

# Install the testsuite
cp -a test ${RPM_BUILD_ROOT}%{_datadir}/tomcat
find ${RPM_BUILD_ROOT}%{_datadir}/tomcat/test -name Makefile | xargs rm -f
find ${RPM_BUILD_ROOT}%{_datadir}/tomcat/test -name "*.pyc" | xargs rm -f

%pre
/usr/sbin/groupadd -g 53 tomcat 2>/dev/null || :
/usr/sbin/useradd -u 53 -g tomcat -c "Tomcat server" \
    -s /sbin/nologin -r -d /var/lib/tomcat tomcat 2>/dev/null || :

%post
/sbin/chkconfig --add tomcat

%preun
if [ $1 = 0 ]; then
    /sbin/service tomcat stop > /dev/null 2>&1
    /sbin/chkconfig --del tomcat
fi

%post -n tomcat-libs
%{_sbindir}/javaconfig \
    %{_libdir}/lib-org-apache-tomcat-util.so \
    %{_libdir}/lib-org-apache-jasper.so \
    %{_libdir}/lib-org-apache-naming-bootstrap.so \
    %{_libdir}/lib-org-apache-naming.so \
    %{_libdir}/lib-org-apache-catalina-bootstrap.so \
    %{_libdir}/lib-org-apache-catalina.so \
    %{_libdir}/lib-org-apache-catalina-ant.so \
    %{_libdir}/lib-org-apache-catalina-ssi.so \
    %{_libdir}/lib-org-apache-coyote.so \
    %{_libdir}/lib-org-apache-coyote-http11.so \
    %{_libdir}/lib-org-apache-catalina-connector-warp.so \
    %{_libdir}/lib-org-apache-jk.so \
    %{_libdir}/lib-com-redhat-tomcat.so \
    %{_datadir}/java/tomcat-util.jar \
    %{_datadir}/java/jasper.jar \
    %{_datadir}/java/bootstrap.jar \
    %{_datadir}/java/naming.jar \
    %{_datadir}/java/catalina.jar \
    %{_datadir}/java/catalina-ant.jar \
    %{_datadir}/java/servlets-ssi.jar \
    %{_datadir}/java/tomcat-coyote.jar \
    %{_datadir}/java/tomcat-http11.jar \
    %{_datadir}/java/tomcat-warp.jar \
    %{_datadir}/java/tomcat-jk.jar \
    %{_datadir}/java/tomcat-redhat.jar

%postun -n tomcat-libs
%{_sbindir}/javaconfig \
    %{_libdir}/lib-org-apache-tomcat-util.so \
    %{_libdir}/lib-org-apache-jasper.so \
    %{_libdir}/lib-org-apache-naming-bootstrap.so \
    %{_libdir}/lib-org-apache-naming.so \
    %{_libdir}/lib-org-apache-catalina-bootstrap.so \
    %{_libdir}/lib-org-apache-catalina.so \
    %{_libdir}/lib-org-apache-catalina-ant.so \
    %{_libdir}/lib-org-apache-catalina-ssi.so \
    %{_libdir}/lib-org-apache-coyote.so \
    %{_libdir}/lib-org-apache-coyote-http11.so \
    %{_libdir}/lib-org-apache-catalina-connector-warp.so \
    %{_libdir}/lib-org-apache-jk.so \
    %{_libdir}/lib-com-redhat-tomcat.so \
    %{_datadir}/java/tomcat-util.jar \
    %{_datadir}/java/jasper.jar \
    %{_datadir}/java/bootstrap.jar \
    %{_datadir}/java/naming.jar \
    %{_datadir}/java/catalina.jar \
    %{_datadir}/java/catalina-ant.jar \
    %{_datadir}/java/servlets-ssi.jar \
    %{_datadir}/java/tomcat-coyote.jar \
    %{_datadir}/java/tomcat-http11.jar \
    %{_datadir}/java/tomcat-warp.jar \
    %{_datadir}/java/tomcat-jk.jar \
    %{_datadir}/java/tomcat-redhat.jar

%triggerpostun -- tomcat < 4.1.24-5
/usr/bin/chsh -s /sbin/nologin tomcat >/dev/null 2>&1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc *.rhug upstream/tomcat/LICENSE upstream/tomcat/*.txt README.multiple *.sql
%dir %{_sysconfdir}/tomcat
%config(noreplace) %{_sysconfdir}/tomcat/jk2.properties
%config(noreplace) %{_sysconfdir}/tomcat/server-noexamples.xml.config
%config(noreplace) %{_sysconfdir}/tomcat/server.xml
%attr(640,root,tomcat) %config(noreplace) %{_sysconfdir}/tomcat/tomcat-users.*
%config(noreplace) %{_sysconfdir}/tomcat/web.xml
%config %{_sysconfdir}/logrotate.d/tomcat
%config %{_sysconfdir}/rc.d/init.d/tomcat
%config(noreplace) %{_sysconfdir}/sysconfig/tomcat
%{_bindir}/*
%{_sbindir}/*
%dir %{_datadir}/tomcat
%{_datadir}/tomcat/common
%{_datadir}/tomcat/conf
%{_datadir}/tomcat/logs
%{_datadir}/tomcat/server
%{_datadir}/tomcat/shared
%{_datadir}/tomcat/webapps
%{_datadir}/tomcat/work
%attr(750,tomcat,tomcat) %dir %{_localstatedir}/log/tomcat
%attr(750,tomcat,tomcat) %dir %{_localstatedir}/cache/tomcat
%attr(755,tomcat,tomcat) %dir %{_localstatedir}/run/tomcat
%dir %{_localstatedir}/lib/tomcat
%dir %{_localstatedir}/lib/tomcat/ROOT
%dir %{_localstatedir}/lib/tomcat/ROOT/WEB-INF
%config(noreplace) %{_localstatedir}/lib/tomcat/ROOT/index.jsp
%config(noreplace) %{_localstatedir}/lib/tomcat/ROOT/WEB-INF/web.xml
%{_localstatedir}/lib/tomcat/ROOT/*.gif
%config(noreplace) %{_localstatedir}/lib/tomcat/*.xml
%{_localstatedir}/lib/tomcat/examples
%{_localstatedir}/lib/tomcat/tomcat-docs
%{_localstatedir}/lib/tomcat/webdav

%files libs
%defattr(-,root,root)
%{_libdir}/*.so
%{_datadir}/java/*.jar

%files devel
%defattr(-,root,root)
%{_includedir}/org/apache/tomcat/util
%{_includedir}/org/apache/jasper
%{_includedir}/org/apache/naming
%{_includedir}/org/apache/catalina
%{_includedir}/org/apache/coyote
%{_includedir}/org/apache/jk
%{_includedir}/com/redhat/tomcat

%files -n mod_jk2
%defattr(-,root,root)
%doc upstream/connectors/jk/native2/*.{txt,html}
%{_libdir}/httpd/modules/mod_jk2.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/jk2.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/workers2.properties

%files test
%defattr(-,root,root)
%{_datadir}/tomcat/test

%changelog
* Tue May  4 2004 Gary Benson <gbenson@redhat.com> 4.1.27-13
- Rebuild with new compiler.

* Thu Apr 15 2004 Gary Benson <gbenson@redhat.com> 4.1.27-12
- Rebuild with new compiler (#120844).

* Tue Apr 13 2004 Gary Benson <gbenson@redhat.com>
- Fix startup detection code in testsuite and a broken testcase.

* Wed Apr  7 2004 Gary Benson <gbenson@redhat.com> 4.1.27-11
- Determine the gcjlib URL prefix correctly.
- Include the webapps again.

* Tue Mar  2 2004 Elliot Lee <sopwith@redhat.com>
- Rebuilt.

* Thu Feb 26 2004 Gary Benson <gbenson@redhat.com>
- Don't build the tomcat executable on ppc64 until -Wl,--wrap works
  properly on that architecture.

* Tue Feb 24 2004 Gary Benson <gbenson@redhat.com> 4.1.27-10
- Remove mod_webapp and fix mod_jk2 installion.
- Temporarily remove the test subpackage's JDBC dependencies.

* Mon Feb 23 2004 Gary Benson <gbenson@redhat.com> 4.1.27-9
- Rebuild for Fedora.

* Mon Feb  2 2004 Gary Benson <gbenson@redhat.com>
- Pick up xerces-j's XML libraries from their new location.

* Fri Jan 23 2004 Gary Benson <gbenson@redhat.com>
- Replace the -sysconf option with a generic JVM-style -D option.
- Add support for passing extra options to the tomcat executable.

* Fri Jan  9 2004 Gary Benson <gbenson@redhat.com>
- Add MBean description for DatasourceRealm.

* Thu Dec 18 2003 Gary Benson <gbenson@redhat.com>
- Add commons-DBCP pooling support.

* Tue Dec 16 2003 Gary Benson <gbenson@redhat.com>
- Upgraded to fluorinated RHUG tarball.
- Picked up an accidentally omitted resource in jasper.jar.
- Removed duplicate class from catalina.jar.
- Removed useless resources from tomcat-coyote.jar.
- Apply hammer multilib fix to all multilib archs.
- Correctly link local libraries on hammer.

* Tue Dec 16 2003 Gary Benson <gbenson@redhat.com>
- Determine at startup whether gcjlib URLs are supported and,
  if they are, whether the prefix is "solib:" or "gcjlib:".

* Tue Dec  9 2003 Gary Benson <gbenson@redhat.com>
- Switch "solib:" URLs to "gcjlib:".

* Wed Nov 12 2003 Gary Benson <gbenson@redhat.com>
- Build the JK connector's classfiles.

* Tue Nov 11 2003 Gary Benson <gbenson@redhat.com> 4.1.27-8
- Rebuild against new ant.

* Thu Nov  6 2003 Gary Benson <gbenson@redhat.com> 4.1.27-7
- Remove unnecessary javamail dependency from the main package.
- Correctly substitute test webapp deployment directories.

* Wed Nov  5 2003 Gary Benson <gbenson@redhat.com> 4.1.27-6
- Fix application reloading (#108108).

* Fri Oct 31 2003 Gary Benson <gbenson@redhat.com>
- Correctly display the JVM version within the manager webapp.

* Fri Oct 24 2003 Gary Benson <gbenson@redhat.com>
- Create the test subpackage.

* Fri Oct 17 2003 Gary Benson <gbenson@redhat.com>
- Enable JavaMail support and build the sendmail example servlet.

* Thu Oct 16 2003 Gary Benson <gbenson@redhat.com>
- Add an example PostgreSQL realm, comment upon the example MySQL
  realm, and remove the Oracle and ODBC realms.

* Mon Oct 13 2003 Gary Benson <gbenson@redhat.com> 4.1.27-5
- Link with -Dgnu.gcj.runtime.VMClassLoader.library_control=never
  and remove the delegation hack.

* Thu Oct  2 2003 Gary Benson <gbenson@redhat.com>
- Fix a variety of linking errors.
- Make the logger independent of the daemon.

* Wed Oct  1 2003 Gary Benson <gbenson@redhat.com>
- Use the common-server-shared classloader heirachy.

* Tue Sep 30 2003 Gary Benson <gbenson@redhat.com>
- Fix the -nonaming command line option in the daemon.

* Fri Sep 12 2003 Gary Benson <gbenson@redhat.com>
- Create links for catalina-ant.jar and servlets-ssi.jar.

* Fri Sep 12 2003 Gary Benson <gbenson@redhat.com> 4.1.27-4
- Also document how to set the nice level in /etc/sysconfig/tomcat.

* Thu Sep 11 2003 Gary Benson <gbenson@redhat.com>
- Rename some of the configuration variables.
- Add options to set permissions on configuration and webapps
  directories on startup, and patch the admin and manager webapps to
  inform the user of how to set them.

* Wed Sep 10 2003 Gary Benson <gbenson@redhat.com>
- Only rotate logfiles if they have something in them.
- Allow multiple invocations to run simultaneously.

* Fri Sep  5 2003 Gary Benson <gbenson@redhat.com> 4.1.27-3
- Ensure we have a working javaconfig.

* Thu Sep  4 2003 Gary Benson <gbenson@redhat.com>
- Remove workarounds used to support alpha releases.

* Fri Aug 22 2003 Gary Benson <gbenson@redhat.com> 4.1.27-2
- Don't link to older libraries when building (#102654).
- Rebuild with new compiler.

* Mon Aug  4 2003 Gary Benson <gbenson@redhat.com> 4.1.27-1
- Upgraded to latest version.

* Fri Aug  1 2003 Gary Benson <gbenson@redhat.com>
- Display a warning page upon logging in to the admin webapp if the
  server's configuration directory is not writable (#101283).

* Thu Jul 31 2003 Gary Benson <gbenson@redhat.com>
- Suppress a spurious exception in the JSP servlet (#98527).
- Omit /etc/tomcat/catalina.policy (it has no effect under libgcj).
- Add JMX stuff for our new logger.
- Add an option to directly set the filename to the new logger.

* Wed Jul 30 2003 Gary Benson <gbenson@redhat.com>
- Replace rather than patch the admin and manager webapps' context
  configuration files to make them easier to modify.
- Mark said files as config(noreplace).
- Create a new logger, integrated with the daemon, that allows tomcat
  to integrate nicely with logrotate (#98525).

* Tue Jul 29 2003 Gary Benson <gbenson@redhat.com> 4.1.24-10
- Tighten up permissions on /etc/tomcat/tomcat-users.xml (#97685).

* Mon Jul 28 2003 Gary Benson <gbenson@redhat.com>
- Add missing resources to jarfiles (#100977).
- Remove some duplicated classes from catalina.jar.

* Fri Jul 25 2003 Gary Benson <gbenson@redhat.com>
- Don't link the daemon to the coyote library.
- Clarify the -devel subpackage's summary and description.
- Remove unnecessary -devel dependencies (#99077).

* Thu Jul 24 2003 Gary Benson <gbenson@redhat.com>
- Don't trample the classloaders of privileged webapps (#98527).
- Embed struts completly in the admin webapp.
- Build with new pseudo-noarch struts and conflict with the old
  native one.

* Wed Jul  2 2003 Gary Benson <gbenson@redhat.com> 4.1.24-9
- Remove some patch backup files that were being installed.
- Enable MBeans support and build the admin webapp.

* Mon Jun 30 2003 Gary Benson <gbenson@redhat.com> 4.1.24-8
- Rebuild with new compiler and enable ia64 build.
- Enable hammer compiler hack on ia64 also.

* Mon Jun 16 2003 Gary Benson <gbenson@redhat.com>
- Also build HTML manager servlet.
- Patch said servlet to only show the WAR upload box if the
  destination directory is writable (not the case in our default
  configuration).

* Fri Jun 13 2003 Gary Benson <gbenson@redhat.com>
- Remove the need for write access to /etc/tomcat (#91007).
- Ship configured for mod_jk2 instead of mod_webapp.
- Add the rpm's release to the version embedded in the libraries.

* Wed Jun 11 2003 Gary Benson <gbenson@redhat.com>
- Move the connectors' libraries back into tomcat-libs.
- Also build mod_jk2.

* Tue Jun 10 2003 Joe Orton <jorton@redhat.com> 4.1.24-7
- Ensure mod_webapp is built using -fPIC (#92299).

* Fri Jun  6 2003 Gary Benson <gbenson@redhat.com> 4.1.24-6
- Rebuild with new compiler and reenable hammer build.

* Wed Jun  4 2003 Gary Benson <gbenson@redhat.com> 4.1.24-5
- Add the capability to invoke catalina as a daemon, fixing a
  number of deficiencies including #91008 and #91793.

* Fri May 30 2003 Gary Benson <gbenson@redhat.com> 4.1.24-4
- Rebuild against new httpd.

* Fri May 23 2003 Gary Benson <gbenson@redhat.com> 4.1.24-3
- Move unversioned library symlinks into -devel subpackage.

* Wed May 21 2003 Gary Benson <gbenson@redhat.com>
- Ensure that the jasper and servletapi jars in use are the same
  as the native code libraries that we are linked against.

* Fri May 16 2003 Gary Benson <gbenson@redhat.com>
- Redirect catalina's output into /var/log/tomcat/catalina.out.
- Move the http11 connector's libraries into the base package and
  move the warp connector's libraries into the mod_webapp subpackage.
- Updated documentation URL in /etc/sysconfig/tomcat.

* Sat May  3 2003 Gary Benson <gbenson@redhat.com> 4.1.24-2
- Fix paths to admin and manager webapps.

* Wed Apr 30 2003 Gary Benson <gbenson@redhat.com>
- Use ant to build webapps.
- Disabled hammer build since ant segfaults.

* Mon Apr 14 2003 Gary Benson <gbenson@redhat.com>
- Require gcj-ssa since we use it to compile JSPs.

* Wed Apr  9 2003 Gary Benson <gbenson@redhat.com> 4.1.24-1
- Initial Red Hat Linux build.

* Thu Apr  3 2003 Gary Benson <gbenson@redhat.com>
- Upgraded to latest version.

* Tue Jan 14 2003 Gary Benson <gbenson@redhat.com>
- Upgraded to latest version.

* Sat Mar  2 2002 Anthony Green <green@redhat.com>
- Initial RHUG build.
